# -*- encoding: utf-8 -*-

from openerp import models, api, fields
from pytz import timezone
from openerp.tools import DEFAULT_SERVER_DATETIME_FORMAT, DEFAULT_SERVER_DATE_FORMAT
from datetime import datetime,timedelta

DATE_FORMAT = '%Y-%m-%d'

class SaleInterestPercentage(models.Model):
    _name = 'sale.interest.percentage'

    name = fields.Char('Nombre')
    value = fields.Float(string='Valor',default=0.0)

class SaleOrder(models.Model):
    _inherit = 'sale.order'
    _name = 'sale.order'

    interest_id = fields.Many2one(
        'sale.interest.percentage',
        string="Interes de venta"
    )

    @api.onchange('interest_id')
    def _calculate_interest(self):
        for order in self:
            for line in order.order_line:
                line.interest_amount = order.interest_id.value
                if line.discount_id and not line.sale_percentage_id:
                    price_unit = line.standard_price - ((line.standard_price * (line.discount_id.value or 0.0))/100)
                    line.price_unit = price_unit + ((price_unit * (line.interest_amount or 0.0))/100)

                if line.sale_percentage_id and not line.discount_id:
                    price_unit = line.standard_price + ((line.standard_price * (line.sale_percentage_id.value or 0.0))/100)
                    line.price_unit = price_unit + ((price_unit * (line.interest_amount or 0.0))/100)

                if line.discount_id and line.sale_percentage_id:
                    price_unit = (line.standard_price - ((line.standard_price * (line.discount_id.value or 0.0))/100)) + (((line.standard_price - ((line.standard_price * (line.discount_id.value or 0.0))/100)) * (line.sale_percentage_id.value or 0.0))/100)
                    line.price_unit = price_unit + ((price_unit * (line.interest_amount or 0.0))/100)


class SaleOrderLine(models.Model):
    _inherit = 'sale.order.line'
    _name = 'sale.order.line'

    interest_amount = fields.Float(string='Interes %',default=0.0)
